Attribute VB_Name = "modTone"
Option Explicit

Dim k1 As Single, k2 As Single, k3 As Single

Public Sub Tone(ArIn() As Long, ArOut() As Long, ByVal Angle As Single)
Dim MaxX As Long, MaxY As Long
Dim x As Long, y As Long
  MaxX = UBound(ArIn(), 1)
  MaxY = UBound(ArIn(), 2)
  Angle = 360 - Angle
  Select Case Angle
    Case 0 To 120
      k2 = Angle / 120
      k1 = 1 - k2
      k3 = 0
    Case 120 To 240
      k3 = (Angle - 120) / 120
      k2 = 1 - k3
      k1 = 0
    Case 240 To 360
      k1 = (Angle - 240) / 120
      k3 = 1 - k1
      k2 = 0
  End Select
  For y = 0 To MaxY
    For x = 0 To MaxX
      ArOut(x, y) = chTone(ArIn(x, y))
    Next x
  Next y
End Sub

Private Function chTone(ByVal v As Long) As Long
Dim r As Long, g As Long, b As Long
Dim fr As Long, fg As Long, fb As Long
  r = (v And &HFF0000) \ &H10000
  g = (v And &HFF00&) \ &H100&
  b = v And &HFF&
  fr = r * k1 + g * k2 + b * k3
  fg = g * k1 + b * k2 + r * k3
  fb = b * k1 + r * k2 + g * k3
  chTone = fr * 65536 + fg * 256 + fb
End Function
